Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ImmutableSet<E>

    java.lang.Object
      com.google.common.collect.ImmutableCollection<E>
          com.google.common.collect.ImmutableSet<E>

All Implemented Interfaces:
  Serializable, Iterable<E>, Collection<E>, Set<E>

Direct Known Subclasses:
  ImmutableSortedSet

    public abstract class ImmutableSet<E>

extends ImmutableCollection<E>
implements Set<E>

A high-performance, immutable `Set` with reliable, user-specified iteration order. Does not permit null elements.

Unlike `Collections.unmodifiableSet(java.util.Set)`, which is a view of a separate collection that can still change, an instance of this class contains its own private data and will never change. This class is convenient for `public static final` sets ("constant sets") and also lets you easily make a "defensive copy" of a set provided to your class by a caller.

Warning: Like most sets, an `ImmutableSet` will not function correctly if an element is modified after being placed in the set. For this reason, and to avoid general confusion, it is strongly recommended to place only immutable objects into this collection.

This class has been observed to perform significantly better than `HashSet` for objects with very fast `Object.hashCode()` implementations (as a well-behaved immutable object should). While this class's factory methods create hash-based instances, the `ImmutableSortedSet` subclass performs binary searches instead.

Note: Although this class is not final, it cannot be subclassed outside its package as it has no public or protected constructors. Thus, instances of this type are guaranteed to be immutable.

Author:
  Kevin Bourrillion, Nick Kralevich
See Also:
  `ImmutableList`, `ImmutableMap`, Serialized Form

Nested Class Summary
`static class` | `ImmutableSet.Builder<E>` A builder for creating immutable set instances, especially `public static final` sets ("constant sets").

Method Summary
`static
`<E> ImmutableSet.Builder<E>`
` | `builder()` Returns a new builder.
`static
`<E> ImmutableSet<E>`
` | `copyOf(Iterable<? extends E> elements)` Returns an immutable set containing the given elements, in order.
`static
`<E> ImmutableSet<E>`
` | `copyOf(Iterator<? extends E> elements)` Returns an immutable set containing the given elements, in order.
`boolean` | `equals(Object object)` Indicates whether some other object is "equal to" this one.
`int` | `hashCode()` Returns a hash code value for the object.
`abstract UnmodifiableIterator<E>` | `iterator()` Returns an unmodifiable iterator across the elements in this collection.
`static
`<E> ImmutableSet<E>`
` | `of()` Returns the empty immutable set.
`static
`<E> ImmutableSet<E>`
` | `of(E... elements)` Returns an immutable set containing the given elements, in order.
`static
`<E> ImmutableSet<E>`
` | `of(E element)` Returns an immutable set containing a single element.
`static
`<E> ImmutableSet<E>`
` | `of(E e1, E e2)` Returns an immutable set containing the given elements, in order.
`static
`<E> ImmutableSet<E>`
` | `of(E e1, E e2, E e3)` Returns an immutable set containing the given elements, in order.
`static
`<E> ImmutableSet<E>`
` | `of(E e1, E e2, E e3, E e4)` Returns an immutable set containing the given elements, in order.
`static
`<E> ImmutableSet<E>`
` | `of(E e1, E e2, E e3, E e4, E e5)` Returns an immutable set containing the given elements, in order.

Methods inherited from class com.google.common.collect.ImmutableCollection
`add, addAll, clear, contains, containsAll, isEmpty, remove, removeAll, retainAll, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Set
`add, addAll, clear, contains, containsAll, isEmpty, remove, removeAll, retainAll, size, toArray, toArray`

Method Detail

### of

    public static <E> ImmutableSet<E> of()

  Returns the empty immutable set. This set behaves and performs comparably to `Collections.emptySet()`, and is preferable mainly for consistency and maintainability of your code.

### of

    public static <E> ImmutableSet<E> of(E element)

  Returns an immutable set containing a single element. This set behaves and performs comparably to `Collections.singleton(T)`, but will not accept a null element. It is preferable mainly for consistency and maintainability of your code.

### of

    public static <E> ImmutableSet<E> of(E e1,
                                         E e2)

  Returns an immutable set containing the given elements, in order. Repeated occurrences of an element (according to `Object.equals(java.lang.Object)`) after the first are ignored.

  Throws:
    `NullPointerException` - if any element is null

### of

    public static <E> ImmutableSet<E> of(E e1,
                                         E e2,
                                         E e3)

  Returns an immutable set containing the given elements, in order. Repeated occurrences of an element (according to `Object.equals(java.lang.Object)`) after the first are ignored.

  Throws:
    `NullPointerException` - if any element is null

### of

    public static <E> ImmutableSet<E> of(E e1,
                                         E e2,
                                         E e3,
                                         E e4)

  Returns an immutable set containing the given elements, in order. Repeated occurrences of an element (according to `Object.equals(java.lang.Object)`) after the first are ignored.

  Throws:
    `NullPointerException` - if any element is null

### of

    public static <E> ImmutableSet<E> of(E e1,
                                         E e2,
                                         E e3,
                                         E e4,
                                         E e5)

  Returns an immutable set containing the given elements, in order. Repeated occurrences of an element (according to `Object.equals(java.lang.Object)`) after the first are ignored.

  Throws:
    `NullPointerException` - if any element is null

### of

    public static <E> ImmutableSet<E> of(E... elements)

  Returns an immutable set containing the given elements, in order. Repeated occurrences of an element (according to `Object.equals(java.lang.Object)`) after the first are ignored (but too many of these may result in the set being sized inappropriately).

  Throws:
    `NullPointerException` - if any of `elements` is null

### copyOf

    public static <E> ImmutableSet<E> copyOf(Iterable<? extends E> elements)

  Returns an immutable set containing the given elements, in order. Repeated occurrences of an element (according to `Object.equals(java.lang.Object)`) after the first are ignored (but too many of these may result in the set being sized inappropriately). This method iterates over `elements` at most once.

  Note that if `s` is a `Set<String>`, then `ImmutableSet.copyOf(s)` returns an `ImmutableSet<String>` containing each of the strings in `s`, while `ImmutableSet.of(s)` returns a `ImmutableSet<Set<String>>` containing one element (the given set itself).

  Note: Despite what the method name suggests, if `elements` is an `ImmutableSet` (but not an `ImmutableSortedSet`), no copy will actually be performed, and the given set itself will be returned.

  Throws:
    `NullPointerException` - if any of `elements` is null

### copyOf

    public static <E> ImmutableSet<E> copyOf(Iterator<? extends E> elements)

  Returns an immutable set containing the given elements, in order. Repeated occurrences of an element (according to `Object.equals(java.lang.Object)`) after the first are ignored.

  Throws:
    `NullPointerException` - if any of `elements` is null

### equals

    public boolean equals(@Nullable
                          Object object)

  Description copied from class: `java.lang.Object`
  Indicates whether some other object is "equal to" this one.

  The `equals` method implements an equivalence relation on non-null object references:

  - It is reflexive: for any non-null reference value `x`, `x.equals(x)` should return `true`.
  - It is symmetric: for any non-null reference values `x` and `y`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
  - It is transitive: for any non-null reference values `x`, `y`, and `z`, if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.
  - It is consistent: for any non-null reference values `x` and `y`, multiple invocations of `x.equals(y)` consistently return `true` or consistently return `false`, provided no information used in `equals` comparisons on the objects is modified.
  - For any non-null reference value `x`, `x.equals(null)` should return `false`.

  The `equals` method for class `Object` implements the most discriminating possible equivalence relation on objects; that is, for any non-null reference values `x` and `y`, this method returns `true` if and only if `x` and `y` refer to the same object (`x == y` has the value `true`).

  Note that it is generally necessary to override the `hashCode` method whenever this method is overridden, so as to maintain the general contract for the `hashCode` method, which states that equal objects must have equal hash codes.

  Specified by:
    `equals` in interface `Collection<E>`
  Specified by:
    `equals` in interface `Set<E>`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `object` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Description copied from class: `java.lang.Object`
  Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by `java.util.Hashtable`.

  The general contract of `hashCode` is:

  - Whenever it is invoked on the same object more than once during an execution of a Java application, the `hashCode` method must consistently return the same integer, provided no information used in `equals` comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application.
  - If two objects are equal according to the `equals(Object)` method, then calling the `hashCode` method on each of the two objects must produce the same integer result.
  - It is not required that if two objects are unequal according to the `Object.equals(java.lang.Object)` method, then calling the `hashCode` method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables.

  As much as is reasonably practical, the hashCode method defined by class `Object` does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)

  Specified by:
    `hashCode` in interface `Collection<E>`
  Specified by:
    `hashCode` in interface `Set<E>`
  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### iterator

    public abstract UnmodifiableIterator<E> iterator()

  Description copied from class: `ImmutableCollection`
  Returns an unmodifiable iterator across the elements in this collection.

  Specified by:
    `iterator` in interface `Iterable<E>`
  Specified by:
    `iterator` in interface `Collection<E>`
  Specified by:
    `iterator` in interface `Set<E>`
  Specified by:
    `iterator` in class `ImmutableCollection<E>`
  Returns:
    an `Iterator` over the elements in this collection

### builder

    public static <E> ImmutableSet.Builder<E> builder()

  Returns a new builder. The generated builder is equivalent to the builder created by the `ImmutableSet.Builder` constructor.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD